﻿using Microsoft.AspNetCore.Http;
using System;

namespace QueryPlatform.Api.Infrastructure.Modules
{
    public class SYS_DEMAND
    {
        /// <summary>
        /// ID
        /// </summary>
        public int id { get; set; }
        /// <summary>
        /// indexs
        /// </summary>
        public long INDEXS { get; set; }
        /// <summary>
        /// 需求描述
        /// </summary>
        public string Demand_Describe { get; set; }
        /// <summary>
        /// 需求名称
        /// </summary>
        public string Demand_Name { get; set; }
        /// <summary>
        /// 需求者
        /// </summary>
        public string Demand_User { get; set; }

    }
    public class SYS_DEMANDSUBLIS
    {
        /// <summary>
        /// ID
        /// </summary>
        public int id { get; set; }

        public IFormFile file { get; set; }
        /// <summary>
        /// 上传人
        /// </summary>
        public string UserName { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string remark { get; set; }
    }
    public class 服务器
    {
        public string 服务器ip { get; set; }
        public string 数据库账号 { get; set; }
        public string 数据库密码 { get; set; }
    }
    public class SYS_Hospital
    {
        public int id { get; set; }
        public string HosName { get; set; }
        public string ExecOpenLink { get; set; }
        public string ExecDatabase { get; set; }
        public string DataLoginName { get; set; }
        public string DataPassword { get; set; }
    }
    public class MEDIC_SEARCH_RECORD
    {
        public int id { get; set; }
        public DateTime end_time { get; set; }
    }
    public class SYS_Cs
    {
        public int id { get; set; }
        public string MEDIC_AREA { get; set; }
        public string item_name { get; set; }
        public string GENERIC_NAME { get; set; }
        public string PROJECT_NAME { get; set; }
        public string DISEASE_NAME { get; set; }
        public string icd { get; set; }

    }
    public class SYS_EstablishFlowDatabaseTable
    {
        public int id { get; set; }
        public string tableName { get; set; }
        public string sql { get; set; }
        public string remarks { get; set; }

    }
    public class COMMONLYUSED
    {
        /// <summary>
        /// 名称
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 函数内容
        /// </summary>
        public string value { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string remarks { get; set; }
    }
    public class SYS_YIYUAN
    {
        public long hosid { get; set; }
        public string hosname { get; set; }
    }
    public class DATAEXTRACT
    {
        public long HOS_ID { get; set; }

        /// <summary>
        /// 开始时间
        /// </summary>
        public DateTime START_TIME { get; set; }
        /// <summary>
        /// 结束时间
        /// </summary>
        public DateTime END_TIME { get; set; }
        /// <summary>
        /// 备注信息
        /// </summary>
        public string REMARK { get; set; }
    }
    public class SYS_EXTRACT
    {
        /// <summary>
        /// 医院编号
        /// </summary>
        public long HOS_ID { get; set; }
        /// <summary>
        /// 服务器
        /// </summary>
        public string SERVER { get; set; }
        /// <summary>
        /// 数据库名称
        /// </summary>
        public string NAME { get; set; }
        /// <summary>
        /// 医院名称
        /// </summary>
        public string HOS_NAME { get; set; }
        /// <summary>
        /// 开始时间
        /// </summary>
        public DateTime START_TIME { get; set; }
        /// <summary>
        /// 结束时间
        /// </summary>
        public DateTime END_TIME { get; set; }
        /// <summary>
        /// 备注信息
        /// </summary>
        public string REMARK { get; set; }
        /// <summary>
        /// 执行人
        /// </summary>
        public string Executor { get; set; }
    }
    public class PUB_PATIENT
    {
        public long 病人编码 { get; set; }
        public string 医院病人编码 { get; set; }
        public string 性别 { get; set; }
        public string 出生日期 { get; set; }
        public string 标准地域 { get; set; }
        public string 民族 { get; set; }
        public string 国籍 { get; set; }
        public long 创建机构 { get; set; }
        public string 病人主索引 { get; set; }
    }
    public class OUT_REG_INFO
    {
        public long 挂号序号 { get; set; }
        public string 医院挂号序号 { get; set; }
        public long 病人编码 { get; set; }
        public string 医院病人编码 { get; set; }
        public string 挂号时间 { get; set; }
        public string 医院挂号科室 { get; set; }
        public string 医院科室名称 { get; set; }
        public string 医保类型 { get; set; }
        public string 急诊_门诊 { get; set; }
        public string 标准一级诊断 { get; set; }
        public string 标准科室 { get; set; }
        public long 创建机构 { get; set; }
        public string 上传时间 { get; set; }
        public string 是否医保 { get; set; }
        public string 总费用 { get; set; }
        public string 自付费用 { get; set; }
    }
    public class OUT_PRES
    {
        public long 处方编号 { get; set; }
        public string 医院处方编号 { get; set; }
        public long 挂号序号 { get; set; }
        public string 医院挂号序号 { get; set; }
        public string 组号 { get; set; }
        public string 处方序号 { get; set; }
        public string 处方时间 { get; set; }
        public string 处方类型 { get; set; }
        public string 药品代码 { get; set; }
        public string 药品分类 { get; set; }
        public string 药品通用名称 { get; set; }
        public string 药品名称 { get; set; }
        public string 药品剂型 { get; set; }
        public string 药品规格 { get; set; }
        public string 药品产地 { get; set; }
        public string 每次用量 { get; set; }
        public string 用量单位 { get; set; }
        public string 用法编码 { get; set; }
        public string 给药方式 { get; set; }
        public string 配药天数 { get; set; }
        public string 配药数量 { get; set; }
        public string 配药单位 { get; set; }
        public string 皮试结果 { get; set; }
        public string 用药备注 { get; set; }
        public string 医保分类 { get; set; }
        public string 创建机构 { get; set; }
    }
    public class OUT_FEE
    {
        public long 收费号 { get; set; }
        public string 上传收费号 { get; set; }
        public long 挂号序号 { get; set; }
        public string 医院挂号序号 { get; set; }
        public string 项目种类 { get; set; }
        public string 上传费用代码 { get; set; }
        public string 费用名称 { get; set; }
        public string 单价 { get; set; }
        public string 费用类别 { get; set; }
        public string 数量 { get; set; }
        public string 单位 { get; set; }
        public string 金额 { get; set; }
        public string 科室编码 { get; set; }
        public string 科室名称 { get; set; }
        public string 收费日期 { get; set; }
        public long 创建机构 { get; set; }
        public string 标准分类名称 { get; set; }
        public string 药品产地 { get; set; }
        public string 执行科室编码 { get; set; }
        public string 执行科室名称 { get; set; }

    }
    public class OUT_DIAG
    {
        public long 诊断序号 { get; set; }
        public string 医院诊断序号 { get; set; }
        public long 挂号序号 { get; set; }
        public string 医院挂号序号 { get; set; }
        public string 诊断编号 { get; set; }
        public string 诊断编码 { get; set; }
        public string 疾病名称 { get; set; }
        public string 诊断日期 { get; set; }
        public string 备注 { get; set; }
        public long 创建机构 { get; set; }
    }
    public class INPAT_REG_INFO
    {
        public long 住院序号 { get; set; }
        public string 医院住院序号 { get; set; }
        public long 病人编码 { get; set; }
        public string 医院病人编号 { get; set; }
        public string 上传入院科室 { get; set; }
        public string 入院科室名称 { get; set; }
        public string 病区名称 { get; set; }
        public string 入院时间 { get; set; }
        public string 出院时间 { get; set; }
        public string 医保类型 { get; set; }
        public string 身高 { get; set; }
        public string 体重 { get; set; }
        public string 入院情况 { get; set; }
        public string 出院情况 { get; set; }
        public string 标准一级诊断 { get; set; }
        public string 标准科室 { get; set; }
        public string 创建机构 { get; set; }
        public string 是否医保 { get; set; }
        public string 腰围 { get; set; }
        public string 总费用 { get; set; }
        public string 自付费用 { get; set; }
        public string 出院科室编码 { get; set; }
        public string 出院科室名称 { get; set; }
        public string 住院病人的来源 { get; set; }
    }
    public class INPAT_ORDER
    {
        public long 医嘱序号 { get; set; }
        public string 上传医嘱序号 { get; set; }
        public long 住院序号 { get; set; }
        public string 医院住院序号 { get; set; }
        public string 医嘱类型 { get; set; }
        public string 项目种类 { get; set; }
        public string 费用代码 { get; set; }
        public string 费用名称 { get; set; }
        public string 皮试结果 { get; set; }
        public string 药品规格 { get; set; }
        public string 每次剂量 { get; set; }
        public string 剂量单位 { get; set; }
        public string 用量个数 { get; set; }
        public string 用量单位 { get; set; }
        public string 药品用法 { get; set; }
        public string 给药方式 { get; set; }
        public string 配药数量 { get; set; }
        public double 单价 { get; set; }
        public string 医嘱天数 { get; set; }
        public string 开始服药日期 { get; set; }
        public string 结束服药日期 { get; set; }
        public long 用药天数 { get; set; }
        public string 备注 { get; set; }
        public long 创建机构 { get; set; }
        public string 药品产地 { get; set; }
    }
    public class INPAT_FEE
    {
        public long 收费号 { get; set; }
        public string 医院收费序号 { get; set; }
        public string 费用类别 { get; set; }
        public long 住院序号 { get; set; }
        public string 医院住院序号 { get; set; }
        public string 项目种类 { get; set; }
        public string 医院费用代码 { get; set; }
        public string 费用名称 { get; set; }
        public string 单价 { get; set; }
        public string 数量 { get; set; }
        public string 药量单位 { get; set; }
        public string 金额 { get; set; }
        public string 收费日期 { get; set; }
        public string 科室编码 { get; set; }
        public string 科室名称 { get; set; }
        public long 创建机构 { get; set; }
        public string 标准分类名称 { get; set; }
        public string 药品产地 { get; set; }
        public string 执行科室编码 { get; set; }
        public string 执行科室名称 { get; set; }
    }
    public class INPAT_DIAG
    {
        public long 诊断序号 { get; set; }
        public string 医院诊断序号 { get; set; }
        public long 住院序号 { get; set; }
        public string 医院住院序号 { get; set; }
        public string 诊断编号 { get; set; }
        public string 编码 { get; set; }
        public string 疾病名称 { get; set; }
        public string 备注 { get; set; }
        public string 诊断类型 { get; set; }
        public string 诊断时间 { get; set; }
        public string 治愈状态 { get; set; }
        public long 创建机构 { get; set; }

    }
    public class EXEC_REPORT
    {
        public long 报告单编号 { get; set; }
        public string 医院报告编号 { get; set; }
        public long 病人序号 { get; set; }
        public string 医院病人序号 { get; set; }
        public long 医嘱序号 { get; set; }
        public string 医院医嘱序号 { get; set; }
        public string 简要病史 { get; set; }
        public string 项目名称 { get; set; }
        public string 诊断表现 { get; set; }
        public string 诊断结论 { get; set; }
        public string 报告时间 { get; set; }
        public long 患者来源 { get; set; }
        public long 创建机构 { get; set; }
    }
    public class ASSAY_REPORT
    {
        public long 化验报告编码 { get; set; }
        public string 医院报告编码 { get; set; }
        public long 病人序号 { get; set; }
        public string 医院病人序号 { get; set; }
        public string 报告时间 { get; set; }
        public string 标本类型 { get; set; }
        public string 化验项目代码 { get; set; }
        public string 项目名称 { get; set; }
        public string 项目e文名 { get; set; }
        public string 结构单位 { get; set; }
        public string 结果单位 { get; set; }
        public string 参考范围 { get; set; }
        public string 结果状态 { get; set; }
        public long 患者来源 { get; set; }
        public long 创建机构 { get; set; }
    }
    public class OPS_INFO
    {
        public long 手术编号 { get; set; }
        public string 医院手术编号 { get; set; }
        public long 住院序号 { get; set; }
        public string 医院住院序号 { get; set; }
        public long 医嘱序号 { get; set; }
        public string 医院医嘱序号 { get; set; }
        public string 医院费用编码 { get; set; }
        public string 手术名称 { get; set; }
        public string 术前诊断 { get; set; }
        public string 手术结果 { get; set; }
        public string 手术等级 { get; set; }
        public string 手术创口等级 { get; set; }
        public string 手术开始时间 { get; set; }
        public string 手术结束时间 { get; set; }
        public string 科室编码 { get; set; }
        public string 科室名称 { get; set; }
        public string 愈合程度 { get; set; }
        public string 麻醉方式 { get; set; }
        public string 择期手术 { get; set; }
        public long 创建机构 { get; set; }
        public string 手术操作编码 { get; set; }
        public string 标准手术名称 { get; set; }
        public string 标准手术操作编码 { get; set; }
    }
    public class PUBPATIENT
    {
        public string MASTER_INDEX { get; set; }
        public string HOS_ID { get; set; }
    }
    public class SYS_LOG
    {
        public int id { get; set; }
        public long INDEXS { get; set; }
        public string HOS_CODE { get; set; }
        public string IP { get; set; }
        public string HOS { get; set; }
        public string LOG { get; set; }
        public DateTime CreateDate { get; set; }
        public string type { get; set; }
        public string 错误sql { get; set; }
    }
    public class DateExploration
    {
        public int id { get; set; }
        public int Id { get; internal set; }
        public string Name1 { get; set; }
        public string Name2 { get; set; }
        public string Name3 { get; set; }
        public string Name4 { get; set; }
        public string Name5 { get; set; }
        public string Name6 { get; set; }
        public string Name7 { get; set; }
        public string Name8 { get; set; }
        public string Name9 { get; set; }
        public string Name10 { get; set; }
    }
    public class DES
    {
        public int id { get; set; }
        public int IsAssay { get; set; }
    }
    public class Sys_cs
    {
        public string zxr { get; set; }
        public int hosid { get; set; }
        public int num { get; set; }
    }
    public class SYS_Drugquery
    {
        /// <summary>
        /// 1 命中查询 2全部查询
        /// </summary>
        public int type1_2 { get; set; }

        public int typefee { get; set; }
        /// <summary>
        /// ICD编码
        /// </summary>
        public string[] icd { get; set; }
        /// <summary>
        /// 疾病名称
        /// </summary>
        public string[] diseaseName { get; set; }
        /// <summary>
        /// 药品名称
        /// </summary>
        public string[] drugName { get; set; }
        /// <summary>
        /// 材料名称
        /// </summary>
        public string[] materialName { get; set; }
        /// <summary>
        /// 项目名称
        /// </summary>
        public string peojectName { get; set; }
    }


    public class abc
    {
        public string 疾病史 { get; set; }
        public string 传染病史 { get; set; }
        public string 手术史外伤史 { get; set; }

        public string 过敏史 { get; set; }
        public string 重要药物应用史 { get; set; }
        public string 预防接种史 { get; set; }
        public string 输血史 { get; set; }
    }

    public class aaaa
    {
        public string zyh { get; set; }
        public string jws { get; set; }
    }
}
